/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.support.avtransport.impl.state;

import org.teleal.cling.support.avtransport.AVTransport;
import org.teleal.cling.support.avtransport.dto.AVTransportState;
import org.teleal.cling.support.avtransport.dto.SeekMode;

/**
 *
 */
public abstract class Playing<T extends AVTransport> extends AbstractState {

    public Playing(T transport) {
        super(transport);
    }

    public abstract Class<? extends AbstractState> setTransportURI(String transportURI, String metaData);
    public abstract Class<? extends AbstractState> stop();
    public abstract Class<? extends AbstractState> play(String speed);
    public abstract Class<? extends AbstractState> pause();
    public abstract Class<? extends AbstractState> next();
    public abstract Class<? extends AbstractState> previous();
    public abstract Class<? extends AbstractState> seek(SeekMode unit, String target);

    public String[] getCurrentTransportActions() {
        return new String[] {
                AVTransportState.ACTION_STOP,
                AVTransportState.ACTION_PLAY,
                AVTransportState.ACTION_PAUSE,
                AVTransportState.ACTION_NEXT,
                AVTransportState.ACTION_PREVIOUS,
                AVTransportState.ACTION_SEEK
        };
    }
}
